#define _WIN32_IE 0x0500
#include <string>
#include <windows.h>
#include <commctrl.h>
#include "Recursos.h"

BOOL CALLBACK UsuarioAgregar (HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK ProductoAgregar (HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK ProductoBusqueda (HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK IngredienteAgregar (HWND, UINT, WPARAM, LPARAM);

/*  Declare Windows procedure  */
LRESULT CALLBACK WindowProcedure (HWND, UINT, WPARAM, LPARAM);

void SeleccionMenu (HWND, WPARAM);

MensajeGlobal Llamada;
HINSTANCE hDialog1, hDialog2;

/*  Make the class name into a global variable  */
char szClassName[ ] = "VentanaAp";

int WINAPI WinMain (HINSTANCE hThisInstance, HINSTANCE hPrevInstance,
                    LPSTR lpszArgument, int nFunsterStil)
{
    HWND hwnd;               /* Este es el handle para nuestra ventana */
    MSG messages;            /* Aqu son grabados los mesanjes de la aplicacin */
    HACCEL hAccel;
    WNDCLASSEX wincl;        /* Estructura de datos para la windowclass */
    INITCOMMONCONTROLSEX icex;
    
    icex.dwSize = sizeof(icex);
    icex.dwICC = ICC_DATE_CLASSES;
    InitCommonControlsEx(&icex);

    /* Estructura de ventana */
    wincl.hInstance = hThisInstance;
    wincl.lpszClassName = szClassName;
    wincl.lpfnWndProc = WindowProcedure;      /* Esta funcin es llamada por Windows */
    wincl.style = CS_DBLCLKS;                 /* Atrapa dobles-clicks */
    wincl.cbSize = sizeof (WNDCLASSEX);

    /* Usa icono y Puntero del mouse por defecto */
    wincl.hIcon = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hIconSm = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hCursor = LoadCursor (NULL, IDC_ARROW);
    wincl.lpszMenuName ="Menu_Principal";  /* Con menu */
    wincl.cbClsExtra = 0;                      /* No extra bytes after the window class */
    wincl.cbWndExtra = 0;                      /* Estructura o instancia de ventana */
    /* Usa por defecto el color y el fondo de Windows */
    wincl.hbrBackground = (HBRUSH) COLOR_BACKGROUND;
    
    /* Registra la clase de ventana, y si falla sale del programa */
    if (!RegisterClassEx (&wincl))
        return 0;

    /* La clase es registrada, y crae el programa */
    hwnd = CreateWindowEx (
           0,                   /* Extended possibilites for variation */
           szClassName,         /* Nombre de la Clase */
           "Restorant Chichmon",       /* Texto del titulo */
           WS_OVERLAPPEDWINDOW, /* Ventana por defecto */
           CW_USEDEFAULT,       /* Windows decide la posicin */
           CW_USEDEFAULT,       /* Donde la ventana termina en la pantalla */
           544,                 /* El ancho del programa */
           375,                 /* Y alto en pixels */
           HWND_DESKTOP,        /* La ventana como ventana hija */
           NULL,                /* No menu */
           hThisInstance,       /* Program Instance handler */
           NULL                 /* No Window Creation data */
           );
           
    hAccel = LoadAccelerators(hThisInstance, "Menu_Principal");
    ShowWindow (hwnd, nFunsterStil);     /* Hace la ventana visible en pantalla */
   
    /* Loop de mensajes, Corre hasta que GetMessage() retorne 0 */
    while (GetMessage (&messages, NULL, 0, 0)){
        if (!TranslateAccelerator (hwnd, hAccel, &messages)){
           TranslateMessage(&messages);
           DispatchMessage(&messages);
        }
    }
    /* The program return-value is 0 - The value that PostQuitMessage() gave */
    return messages.wParam;
}


/*  This function is called by the Windows function DispatchMessage()  */

LRESULT CALLBACK WindowProcedure (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
 switch (message){
      case WM_COMMAND:
           SeleccionMenu (hwnd, wParam); 
           break;
      case WM_DESTROY:
           PostQuitMessage (0);
           break;
      default:
            return DefWindowProc (hwnd, message, wParam, lParam);
 }
 return 0;
}

BOOL CALLBACK ProductoAgregar (HWND hCDialog, UINT mensaje, WPARAM wParam, LPARAM lParam)
{
 switch (mensaje){
        case WM_COMMAND:
            switch (LOWORD(wParam)){
                    case IDCANCEL:
                        EndDialog (hCDialog,0);
                        return 1;
                    case IDOK:
                        MessageBox(hCDialog, "Ficha lista", "Producto", MB_OK);
                        EndDialog (hCDialog,0);
                        return 1;             
            }
 }
       
}

BOOL CALLBACK ProductoBusqueda (HWND hCDialog, UINT mensaje, WPARAM wParam, LPARAM lParam)
{
 switch (mensaje){
        case WM_INITDIALOG:
             SendDlgItemMessage(hCDialog, IDC_COMBO1, CB_ADDSTRING, 0, (LPARAM)"Descripcin");
             SendDlgItemMessage(hCDialog, IDC_COMBO1, CB_ADDSTRING, 0, (LPARAM)"Cdigo");
             SendDlgItemMessage(hCDialog, IDC_COMBO1, CB_SELECTSTRING, (WPARAM)-1, (LPARAM)"Descripcin");
             SetFocus(GetDlgItem(hCDialog, IDC_COMBO1));
        break;
        case WM_COMMAND:
            switch (LOWORD(wParam)){
                    case IDCANCEL:
                        EndDialog (hCDialog,0);
                        return 1;
                    case IDOK:
                        MessageBox(hCDialog, "Ficha lista", "Producto", MB_OK);
                        EndDialog (hCDialog,0);
                        return 1;
            }
 }

}

BOOL CALLBACK IngredienteAgregar (HWND hCDialog, UINT mensaje, WPARAM wParam, LPARAM lParam)
{
 switch (mensaje){
        case WM_COMMAND:
            switch (LOWORD(wParam)){
                    case IDCANCEL:
                        EndDialog (hCDialog,0);
                        return 1;
                    case IDOK:
                        MessageBox(hCDialog, "Ficha lista", "Producto", MB_OK);
                        EndDialog (hCDialog,0);
                        return 1;
            }
 }

}

BOOL CALLBACK UsuarioAgregar (HWND hCDialog, UINT mensaje, WPARAM wParam, LPARAM lParam)
{
 switch (mensaje){
        case WM_COMMAND:
            switch (LOWORD(wParam)){
                    case IDCANCEL:
                        EndDialog (hCDialog,0);
                        return 1;
                    case IDOK:
                        MessageBox(hCDialog, "Ficha lista", "Producto", MB_OK);
                        EndDialog (hCDialog,0);
                        return 1;
            }
 }

}

void SeleccionMenu (HWND hwnd, WPARAM wParam)
{
    int Respuesta;
    char Cadena[255];
    
    switch(wParam){
        case IDM_SALIR_DEL_PROGRAMA:
            Respuesta = MessageBox (hwnd, "Desea abandonar el programa?", "Chanchich", MB_YESNO);
            if (Respuesta == IDYES){
                PostQuitMessage(0);
            }    
            break;
        case IDM_BUSCAR_PRODUCTO:
            DialogBox (hDialog1,"CD_Producto_busqueda", hwnd,(DLGPROC)ProductoBusqueda);
            break;        
        case IDM_AGREGAR_PRODUCTO:            
            DialogBox(hDialog1, "CD_Producto_Agregar", hwnd, (DLGPROC)ProductoAgregar);
            break;
        case IDM_AGREGAR_INGREDIENTE:
            DialogBox(hDialog1, "CD_Ingrediente_agregar", hwnd, (DLGPROC)IngredienteAgregar);
            break;    
        case  IDM_AGREGAR_USUARIO:
            DialogBox(hDialog1, "CD_Usuario_Agregar", hwnd, (DLGPROC)UsuarioAgregar);
            break; 
        default:
            sprintf (Cadena, "Opcin : %04d", (int)wParam);
            MessageBox (hwnd, Cadena, "Desconocido", MB_ICONEXCLAMATION);
            break;  
    }
    return;
}
